FA HW4
======

Cheng-Hsi Chao

2.12
----

### a)

    procedure DFS(v):
        for w in childrenOf(v):
            w.ans = w.dat + v.dat
            DFS(w)
        if v is root:
        # This could be checked by if not v.ans:
            v.ans = v.dat

### b)

    function DFS(v):
        v.ans = v.dat
        for w in childrenOf(v):
            v.ans += DFS(w)
        return v.ans

### c)

    function DFS(v):
        v.ans = DFS(v.left)
        v.ans += v.dat
        DFS(v.right)
        return v.ans   

### d)

arbitary tree, sum up everthing in first pass, and then minus out the
preorder in second pass

    Global result
    procedure DFSdriver(v):
        result += v.dat
        for w in childrenOf(v):
            DFSdriver(v)

    procedure DFS(v):
        if v is root:
        # This could be checked by if not v.ans:
            v.ans = result - v.dat
        for w in childrenOf(v):
            w.ans = v.ans - w.dat
        return v.ans

### e)

For a Tree T PreOrder: ABDEC PostOrder: DEBAC For value x, print the
PreOrder values before x but exclude the value in PostOrder before x

    global sum = 0
    procedure DFS(v):
        v.ans = sum
        for w in childrenOf(v):
            # Take yourself down, but delete yourself when coming back up
            sum = sum + v.dat
            DFS(w)
            sum = sum - v.dat

Or, alternatively:

    procedure DFS(v):
        if v is root:
        # This could be checked by if not v.ans:
            v.ans = nil(or 0)
        for w in childrenOf(v):
            w.ans = v.ans + v.dat
            DFS(w)

Ex 3.2
------

### a) \\Checkmark

$32n < nlog_2$ since n is not 0: $32 < log_2n\\$ Answer:
$\underline{n > 2^{32}}$

### b) \\Checkmark

$32n<n^2$ since n is not 0, we can slash off a n

Answer: $\underline{32<n}$

### c) \\Checkmark

$32nlog_2n<n^2\\$ since n is not 0: $log_2n < n/32\\$ when
$n = 2^8: log_2n = n/32\\$ Answer: $\underline{n > 2^8}$

Ex 3.3 \\Checkmark
------------------

Educated guesses:
$(log_2n)^n > (log_2n)^{log_2n}\\ n^{log_2n} > n^{log_2log_2n} > n^{1/log_2n}\\ 1.0000001^n > 10010n+1.000000000001^n > 1001n^{10010001} >2 > (1/2)^n$

Then by getting logs we can solve for result:

Answer:
$\underline{(log_2n)^n >1.0000001^n > 10010n+1.000000000001^n > n^{log_2n}>}\\ \underline{(log_2n)^{log_2n} = n^{log_2log_2n} > 1001n^{10010001} > n^{1/log_2n} = 2 > (1/2)^n}$

Ex 3.4
------

### a) \\Checkmark

$T(n) = \Theta(1)$ for n = 1 $T(n)=T(n-1)+ \Theta(1)$ for n > 1

### b) \\Checkmark

$V(n) = \Theta(1)$ for n = 1 $V(n)=V(n-1)+\Theta(1)$ for n > 1

### c) \\Checkmark

$V(n) = \Theta(1)$ for n = 1 $W(n)=2W(n-1)+\Theta(1)$ for n > 1

### d)

$X(n) = \Theta(1)$ for n = 1 $X(n) = \Theta(1)$ for n = 2
$X(n)=X(n-1)+X(n-2)$ for n > 1

\$

Ex 3.5
------

a, b1, b, c1, c, d, f1, f, g

Ex 3.6
------

$e^{\sqrt n}$

Ex 3.13
-------

$R(n)$ as expected number of operations for $Rand(N)$ $R(n) = \Theta(1)$
for n = 1 $R(n)=R(n)/3+R(n-1)+\Theta(1)$ for n > 1

Ex 3.17
-------

$Name(1) = 1\\ Name(2k) = 2Name(k)-1$ for n is even and let n =2k
$Name(2k+1) = 2Name(k) + 1$ for n is odd and let $n =2k+1$

Ex 3.18
-------

### a)

so when $T(n) =4n^2, T(n/2) = 4n^2$ because it is smaller than
$1024n+2T(n/2)\\ T(n) =4n^2\\ T(n)=1024n+2T(n/2)=1024n+2*4(n/2)^2=1024n+2n^2\\ n=512$

### b)

for the top levels of the recursion tree, we would be using
$1024n+2T(n/2)$, when $n=2^10$ we have the base case $1024+2T(512)$
$T(n)=1024n(k+1)+T(10)=1024n(k+1)+1024*2^{10}+2*4*512^2$
$\frac{n}{2^k}=2^{11}=>k=log_2n-11\\$

Answer: $\underline{2^{10}nlog_2n-10*2^{10}n+3*2^{20}}$

Ex 3.28
-------

### a)
